Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Friends

# GDALDataset Class Reference

A set of associated raster bands, usually from one file. More...

`#include <gdal_priv.h>`

Inheritance diagram for GDALDataset:

List of all members.

## Public Member Functions
virtual | ~GDALDataset ()
| Destroy an open GDALDataset.
int | GetRasterXSize (void)
| Fetch raster width in pixels.
int | GetRasterYSize (void)
| Fetch raster height in pixels.
int | GetRasterCount (void)
| Fetch the number of raster bands on this dataset.
GDALRasterBand * | GetRasterBand (int)
| Fetch a band object for a dataset.
virtual void | FlushCache (void)
| Flush all write cached data to disk.
virtual const char * | GetProjectionRef (void)
| Fetch the projection definition string for this dataset.
virtual CPLErr | SetProjection (const char *)
virtual CPLErr | GetGeoTransform (double *)
| Fetch the affine transformation coefficients.
virtual CPLErr | SetGeoTransform (double *)
virtual CPLErr | AddBand (GDALDataType eType, char **papszOptions=NULL)
| Add a band to a dataset.
virtual void * | GetInternalHandle (const char *)
virtual GDALDriver * | GetDriver (void)
| Fetch the driver to which this dataset relates.
virtual char ** | GetFileList (void)
| Fetch files forming dataset.
virtual const char * | GetDriverName ()
virtual int | GetGCPCount ()
| Get number of GCPs.
virtual const char * | GetGCPProjection ()
| Get output projection for GCPs.
virtual const GDAL_GCP * | GetGCPs ()
| Fetch GCPs.
virtual CPLErr | SetGCPs (int nGCPCount, const GDAL_GCP *pasGCPList, const char *pszGCPProjection)
| Assign GCPs.
virtual CPLErr | AdviseRead (int nXOff, int nYOff, int nXSize, int nYSize, int nBufXSize, int nBufYSize, GDALDataType eDT, int nBandCount, int *panBandList, char **papszOptions)
| Advise driver of upcoming read requests.
virtual CPLErr | CreateMaskBand (int nFlagsIn)
| Adds a mask band to the dataset.
virtual GDALAsyncReader * | BeginAsyncReader (int nXOff, int nYOff, int nXSize, int nYSize, void *pBuf, int nBufXSize, int nBufYSize, GDALDataType eBufType, int nBandCount, int *panBandMap, int nPixelSpace, int nLineSpace, int nBandSpace, char **papszOptions)
| Sets up an asynchronous data request.
virtual void | EndAsyncReader (GDALAsyncReader *)
| End asynchronous request.
CPLErr | RasterIO (GDALRWFlag, int, int, int, int, void *, int, int, GDALDataType, int, int *, GSpacing, GSpacing, GSpacing, GDALRasterIOExtraArg *psExtraArg)
| Read/write a region of image data from multiple bands.
int | Reference ()
| Add one to dataset reference count.
int | Dereference ()
| Subtract one from dataset reference count.
GDALAccess | GetAccess ()
int | GetShared ()
| Returns shared flag.
void | MarkAsShared ()
| Mark this dataset as available for sharing.
void | MarkSuppressOnClose ()
char ** | GetOpenOptions ()
CPLErr | BuildOverviews (const char *, int, int *, int, int *, GDALProgressFunc, void *)
| Build raster overview(s).
void | ReportError (CPLErr eErrClass, int err_no, const char *fmt,...)
| Emits an error related to a dataset.
virtual int | GetLayerCount ()
| Get the number of layers in this dataset.
virtual OGRLayer * | GetLayer (int)
virtual OGRLayer * | GetLayerByName (const char *)
| Fetch a layer by name.
virtual OGRErr | DeleteLayer (int)
| Delete the indicated layer from the datasource.
virtual int | TestCapability (const char *)
virtual OGRLayer * | CreateLayer (const char *pszName, OGRSpatialReference *poSpatialRef=NULL, OGRwkbGeometryType eGType=wkbUnknown, char **papszOptions=NULL)
| This method attempts to create a new layer on the dataset with the indicated name, coordinate system, geometry type.
virtual OGRLayer * | CopyLayer (OGRLayer *poSrcLayer, const char *pszNewName, char **papszOptions=NULL)
| Duplicate an existing layer.
virtual OGRStyleTable * | GetStyleTable ()
| Returns dataset style table.
virtual void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
| Set dataset style table.
virtual void | SetStyleTable (OGRStyleTable *poStyleTable)
| Set dataset style table.
virtual OGRLayer * | ExecuteSQL (const char *pszStatement, OGRGeometry *poSpatialFilter, const char *pszDialect)
| Execute an SQL statement against the data store.
virtual void | ReleaseResultSet (OGRLayer *poResultsSet)
| Release results of ExecuteSQL().
int | GetRefCount () const
| Fetch reference count.
int | GetSummaryRefCount () const
| Fetch reference count of datasource and all owned layers.
OGRErr | Release ()
virtual OGRErr | StartTransaction (int bForce=FALSE)
virtual OGRErr | CommitTransaction ()
| For datasources which support transactions, CommitTransaction commits a transaction.
virtual OGRErr | RollbackTransaction ()
| For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction.
GDALSQLParseInfo * | BuildParseInfo (swq_select *psSelectInfo, swq_select_parse_options *poSelectParseOptions)
void | DestroyParseInfo (GDALSQLParseInfo *psParseInfo)
OGRLayer * | ExecuteSQL (const char *pszStatement, OGRGeometry *poSpatialFilter, const char *pszDialect, swq_select_parse_options *poSelectParseOptions)
## Static Public Member Functions
static GDALDataset ** | GetOpenDatasets (int *pnDatasetCount)
| Fetch all open GDAL dataset handles.
static int | IsGenericSQLDialect (const char *pszDialect)
## Protected Member Functions
void | RasterInitialize (int, int)
void | SetBand (int, GDALRasterBand *)
virtual CPLErr | IBuildOverviews (const char *, int, int *, int, int *, GDALProgressFunc, void *)
virtual CPLErr | IRasterIO (GDALRWFlag, int, int, int, int, void *, int, int, GDALDataType, int, int *, GSpacing, GSpacing, GSpacing, GDALRasterIOExtraArg *psExtraArg)
CPLErr | BlockBasedRasterIO (GDALRWFlag, int, int, int, int, void *, int, int, GDALDataType, int, int *, GSpacing, GSpacing, GSpacing, GDALRasterIOExtraArg *psExtraArg)
void | BlockBasedFlushCache ()
CPLErr | ValidateRasterIOOrAdviseReadParameters (const char *pszCallingFunc, int *pbStopProcessingOnCENone, int nXOff, int nYOff, int nXSize, int nYSize, int nBufXSize, int nBufYSize, int nBandCount, int *panBandMap)
virtual int | CloseDependentDatasets ()
| Drop references to any other datasets referenced by this dataset.
int | ValidateLayerCreationOptions (const char *const *papszLCO)
int | EnterReadWrite (GDALRWFlag eRWFlag)
void | LeaveReadWrite ()
virtual OGRLayer * | ICreateLayer (const char *pszName, OGRSpatialReference *poSpatialRef=NULL, OGRwkbGeometryType eGType=wkbUnknown, char **papszOptions=NULL)
| This method attempts to create a new layer on the dataset with the indicated name, coordinate system, geometry type.
OGRErr | ProcessSQLCreateIndex (const char *)
OGRErr | ProcessSQLDropIndex (const char *)
OGRErr | ProcessSQLDropTable (const char *)
OGRErr | ProcessSQLAlterTableAddColumn (const char *)
OGRErr | ProcessSQLAlterTableDropColumn (const char *)
OGRErr | ProcessSQLAlterTableAlterColumn (const char *)
OGRErr | ProcessSQLAlterTableRenameColumn (const char *)
## Protected Attributes
GDALDriver * | poDriver
GDALAccess | eAccess
int | nRasterXSize
int | nRasterYSize
int | nBands
GDALRasterBand ** | papoBands
int | bForceCachedIO
int | nRefCount
int | bShared
GByte | bIsInternal
GByte | bSuppressOnClose
GByte | bReserved1
GByte | bReserved2
GDALDefaultOverviews | oOvManager
char ** | papszOpenOptions
OGRStyleTable * | m_poStyleTable
## Friends
class | GDALDriver
class | GDALDefaultOverviews
class | GDALProxyDataset
class | GDALDriverManager
class | GDALRasterBand
GDALDatasetH | GDALOpenEx (const char *pszFilename, unsigned int nOpenFlags, const char *const *papszAllowedDrivers, const char *const *papszOpenOptions, const char *const *papszSiblingFiles)
| Open a raster or vector file as a GDALDataset.
void | GDALClose (GDALDatasetH hDS)
| Close GDAL dataset.

## Detailed Description

A set of associated raster bands, usually from one file.

A dataset encapsulating one or more raster bands.

Details are further discussed in the GDAL Data Model.

Use GDALOpen() or GDALOpenShared() to create a GDALDataset for a named file, or GDALDriver::Create() or GDALDriver::CreateCopy() to create a new dataset.

## Constructor & Destructor Documentation

GDALDataset::~GDALDataset | ( |  | ) | `[virtual]`

Destroy an open GDALDataset.

This is the accepted method of closing a GDAL dataset and deallocating all resources associated with it.

Equivalent of the C callable GDALClose(). Except that GDALClose() first decrements the reference count, and then closes only if it has dropped to zero.

For Windows users, it is not recommended to use the delete operator on the dataset object because of known issues when allocating and freeing memory across module boundaries. Calling GDALClose() is then a better option.

## Member Function Documentation

CPLErr GDALDataset::AddBand | ( | GDALDataType | eType,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | `[virtual]`

Add a band to a dataset.

This method will add a new band to the dataset if the underlying format supports this action. Most formats do not.

Note that the new GDALRasterBand is not returned. It may be fetched after successful completion of the method by calling GDALDataset::GetRasterBand(GDALDataset::GetRasterCount()) as the newest band will always be the last band.

Parameters:

  | eType | the data type of the pixels in the new band.
  | papszOptions | a list of NAME=VALUE option strings. The supported options are format specific. NULL may be passed by default.

Returns:
  CE_None on success or CE_Failure on failure.

Reimplemented in VRTDataset, and VRTWarpedDataset.

CPLErr GDALDataset::AdviseRead | ( | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | char ** | papszOptions |
| ) |  |  | `[virtual]`

Advise driver of upcoming read requests.

Some GDAL drivers operate more efficiently if they know in advance what set of upcoming read requests will be made. The AdviseRead() method allows an application to notify the driver of the region and bands of interest, and at what resolution the region will be read.

Many drivers just ignore the AdviseRead() call, but it can dramatically accelerate access via some drivers.

Parameters:

  | nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  | nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  | nXSize | The width of the region of the band to be accessed in pixels.
  | nYSize | The height of the region of the band to be accessed in lines.
  | nBufXSize | the width of the buffer image into which the desired region is to be read, or from which it is to be written.
  | nBufYSize | the height of the buffer image into which the desired region is to be read, or from which it is to be written.
  | eBufType | the type of the pixel values in the pData data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  | nBandCount | the number of bands being read or written.
  | panBandMap | the list of nBandCount band numbers being read/written. Note band numbers are 1 based. This may be NULL to select the first nBandCount bands.
  | papszOptions | a list of name=value strings with special control options. Normally this is NULL.

Returns:
  CE_Failure if the request is invalid and CE_None if it works or is ignored.

Reimplemented in GDALProxyDataset.

GDALAsyncReader * GDALDataset::BeginAsyncReader | ( | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pBuf,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | int | nPixelSpace,
|  | int | nLineSpace,
|  | int | nBandSpace,
|  | char ** | papszOptions |
| ) |  |  | `[virtual]`

Sets up an asynchronous data request.

This method establish an asynchronous raster read request for the indicated window on the dataset into the indicated buffer. The parameters for windowing, buffer size, buffer type and buffer organization are similar to those for GDALDataset::RasterIO(); however, this call only launches the request and filling the buffer is accomplished via calls to GetNextUpdatedRegion() on the return GDALAsyncReader session object.

Once all processing for the created session is complete, or if no further refinement of the request is required, the GDALAsyncReader object should be destroyed with the GDALDataset::EndAsyncReader() method.

Note that the data buffer (pData) will potentially continue to be updated as long as the session lives, but it is not deallocated when the session (GDALAsyncReader) is destroyed with EndAsyncReader(). It should be deallocated by the application at that point.

Additional information on asynchronous IO in GDAL may be found at: http://trac.osgeo.org/gdal/wiki/rfc24_progressive_data_support

This method is the same as the C GDALBeginAsyncReader() function.

Parameters:

  | nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  | nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  | nXSize | The width of the region of the band to be accessed in pixels.
  | nYSize | The height of the region of the band to be accessed in lines.
  | pBuf | The buffer into which the data should be read. This buffer must contain at least nBufXSize * nBufYSize * nBandCount words of type eBufType. It is organized in left to right,top to bottom pixel order. Spacing is controlled by the nPixelSpace, and nLineSpace parameters.
  | nBufXSize | the width of the buffer image into which the desired region is to be read, or from which it is to be written.
  | nBufYSize | the height of the buffer image into which the desired region is to be read, or from which it is to be written.
  | eBufType | the type of the pixel values in the pData data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  | nBandCount | the number of bands being read or written.
  | panBandMap | the list of nBandCount band numbers being read/written. Note band numbers are 1 based. This may be NULL to select the first nBandCount bands.
  | nPixelSpace | The byte offset from the start of one pixel value in pData to the start of the next pixel value within a scanline. If defaulted (0) the size of the datatype eBufType is used.
  | nLineSpace | The byte offset from the start of one scanline in pData to the start of the next. If defaulted the size of the datatype eBufType * nBufXSize is used.
  | nBandSpace | the byte offset from the start of one bands data to the start of the next. If defaulted (zero) the value will be nLineSpace * nBufYSize implying band sequential organization of the data buffer.
  | papszOptions | Driver specific control options in a string list or NULL. Consult driver documentation for options supported.

Returns:
  The GDALAsyncReader object representing the request.

CPLErr GDALDataset::BuildOverviews | ( | const char * | pszResampling,
|  | int | nOverviews,
|  | int * | panOverviewList,
|  | int | nListBands,
|  | int * | panBandList,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData |
| ) |  |  |

Build raster overview(s).

If the operation is unsupported for the indicated dataset, then CE_Failure is returned, and CPLGetLastErrorNo() will return CPLE_NotSupported.

This method is the same as the C function GDALBuildOverviews().

Parameters:

  | pszResampling | one of "NEAREST", "GAUSS", "CUBIC", "AVERAGE", "MODE", "AVERAGE_MAGPHASE" or "NONE" controlling the downsampling method applied.
  | nOverviews | number of overviews to build.
  | panOverviewList | the list of overview decimation factors to build.
  | nListBands | number of bands to build overviews for in panBandList. Build for all bands if this is 0.
  | panBandList | list of band numbers.
  | pfnProgress | a function to call to report progress, or NULL.
  | pProgressData | application data to pass to the progress function.

Returns:
  CE_None on success or CE_Failure if the operation doesn't work.

For example, to build overview level 2, 4 and 8 on all bands the following call could be made:

       int       anOverviewList[3] = { 2, 4, 8 };

       poDataset->BuildOverviews( "NEAREST", 3, anOverviewList, 0, NULL,
                                  GDALDummyProgress, NULL );

See also:
  GDALRegenerateOverviews()

int GDALDataset::CloseDependentDatasets | ( |  | ) | `[protected, virtual]`

Drop references to any other datasets referenced by this dataset.

This method should release any reference to other datasets (e.g. a VRT dataset to its sources), but not close the current dataset itself.

If at least, one reference to a dependent dataset has been dropped, this method should return TRUE. Otherwise it *should* return FALSE. (Failure to return the proper value might result in infinite loop)

This method can be called several times on a given dataset. After the first time, it should not do anything and return FALSE.

The driver implementation may choose to destroy its raster bands, so be careful not to call any method on the raster bands afterwards.

Basically the only safe action you can do after calling CloseDependantDatasets() is to call the destructor.

Note: the only legitimate caller of CloseDependantDatasets() is GDALDriverManager::~GDALDriverManager()

Returns:
  TRUE if at least one reference to another dataset has been dropped.

Reimplemented in GDALJP2AbstractDataset, VRTDataset, and VRTWarpedDataset.

OGRErr GDALDataset::CommitTransaction | ( |  | ) | `[virtual]`

For datasources which support transactions, CommitTransaction commits a transaction.

If no transaction is active, or the commit fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_UNSUPPORTED_OPERATION.

Depending on drivers, this may or may not abort layer sequential readings that are active.

This function is the same as the C function GDALDatasetCommitTransaction().

Returns:
  OGRERR_NONE on success.

Since:
  GDAL 2.0

Reimplemented in OGRMutexedDataSource.

OGRLayer * GDALDataset::CopyLayer | ( | OGRLayer * | poSrcLayer,
|  | const char * | pszNewName,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | `[virtual]`

Duplicate an existing layer.

This method creates a new layer, duplicate the field definitions of the source layer and then duplicate each features of the source layer. The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation. The source layer may come from another dataset.

This method is the same as the C function GDALDatasetCopyLayer() and the deprecated OGR_DS_CopyLayer().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | poSrcLayer | source layer.
  | pszNewName | the name of the layer to create.
  | papszOptions | a StringList of name=value options. Options are driver specific.

Returns:
  an handle to the layer, or NULL if an error occurs.

Reimplemented in OGRMutexedDataSource.

OGRLayer * GDALDataset::CreateLayer | ( | const char * | pszName,
|  | OGRSpatialReference * | poSpatialRef = `NULL`,
|  | OGRwkbGeometryType | eGType = `wkbUnknown`,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | `[virtual]`

This method attempts to create a new layer on the dataset with the indicated name, coordinate system, geometry type.

The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

In GDAL 2.0, drivers should extend the ICreateLayer() method and not CreateLayer(). CreateLayer() adds validation of layer creation options, before delegating the actual work to ICreateLayer().

This method is the same as the C function GDALDatasetCreateLayer() and the deprecated OGR_DS_CreateLayer().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | hDS | the dataset handle
  | pszName | the name for the new layer. This should ideally not match any existing layer on the datasource.
  | poSpatialRef | the coordinate system to use for the new layer, or NULL if no coordinate system is available.
  | eGType | the geometry type for the layer. Use wkbUnknown if there are no constraints on the types geometry to be written.
  | papszOptions | a StringList of name=value options. Options are driver specific.

Returns:
  NULL is returned on failure, or a new OGRLayer handle on success.

Example:

    #include "gdal.h"
    #include "cpl_string.h"

    ...

            OGRLayer *poLayer;
            char     **papszOptions;

            if( !poDS->TestCapability( ODsCCreateLayer ) )
            {
            ...
            }

            papszOptions = CSLSetNameValue( papszOptions, "DIM", "2" );
            poLayer = poDS->CreateLayer( "NewLayer", NULL, wkbUnknown,
                                         papszOptions );
            CSLDestroy( papszOptions );

            if( poLayer == NULL )
            {
                ...
            }

CPLErr GDALDataset::CreateMaskBand | ( | int | nFlags | ) | `[virtual]`

Adds a mask band to the dataset.

The default implementation of the CreateMaskBand() method is implemented based on similar rules to the .ovr handling implemented using the GDALDefaultOverviews object. A TIFF file with the extension .msk will be created with the same basename as the original file, and it will have one band. The mask images will be deflate compressed tiled images with the same block size as the original image if possible.

Note that if you got a mask band with a previous call to GetMaskBand(), it might be invalidated by CreateMaskBand(). So you have to call GetMaskBand() again.

Since:
  GDAL 1.5.0

Parameters:

  | nFlags | ignored. GMF_PER_DATASET will be assumed.

Returns:
  CE_None on success or CE_Failure on an error.

See also:
  http://trac.osgeo.org/gdal/wiki/rfc15_nodatabitmask

Reimplemented in GDALProxyDataset, and VRTDataset.

OGRErr GDALDataset::DeleteLayer | ( | int | iLayer | ) | `[virtual]`

Delete the indicated layer from the datasource.

If this method is supported the ODsCDeleteLayer capability will test TRUE on the GDALDataset.

This method is the same as the C function GDALDatasetDeleteLayer() and the deprecated OGR_DS_DeleteLayer().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | iLayer | the index of the layer to delete.

Returns:
  OGRERR_NONE on success, or OGRERR_UNSUPPORTED_OPERATION if deleting layers is not supported for this datasource.

Reimplemented in OGRMutexedDataSource.

int GDALDataset::Dereference | ( |  | ) |

Subtract one from dataset reference count.

The reference is one after instantiation. Generally when the reference count has dropped to zero the dataset may be safely deleted (closed).

This method is the same as the C GDALDereferenceDataset() function.

Returns:
  the post-decrement reference count.

void GDALDataset::EndAsyncReader | ( | GDALAsyncReader * | poARIO | ) | `[virtual]`

End asynchronous request.

This method destroys an asynchronous io request and recovers all resources associated with it.

This method is the same as the C function GDALEndAsyncReader().

Parameters:

  | poARIO | pointer to a GDALAsyncReader

OGRLayer * GDALDataset::ExecuteSQL | ( | const char * | pszStatement,
|  | OGRGeometry * | poSpatialFilter,
|  | const char * | pszDialect |
| ) |  |  | `[virtual]`

Execute an SQL statement against the data store.

The result of an SQL query is either NULL for statements that are in error, or that have no results set, or an OGRLayer pointer representing a results set from the query. Note that this OGRLayer is in addition to the layers in the data store and must be destroyed with ReleaseResultSet() before the dataset is closed (destroyed).

This method is the same as the C function GDALDatasetExecuteSQL() and the deprecated OGR_DS_ExecuteSQL().

For more information on the SQL dialect supported internally by OGR review the OGR SQL document. Some drivers (ie. Oracle and PostGIS) pass the SQL directly through to the underlying RDBMS.

Starting with OGR 1.10, the SQLITE dialect can also be used.

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | pszStatement | the SQL statement to execute.
  | poSpatialFilter | geometry which represents a spatial filter. Can be NULL.
  | pszDialect | allows control of the statement dialect. If set to NULL, the OGR SQL engine will be used, except for RDBMS drivers that will use their dedicated SQL engine, unless OGRSQL is explicitly passed as the dialect. Starting with OGR 1.10, the SQLITE dialect can also be used.

Returns:
  an OGRLayer containing the results of the query. Deallocate with ReleaseResultSet().

Reimplemented in OGRMutexedDataSource.

void GDALDataset::FlushCache | ( | void |  | ) | `[virtual]`

Flush all write cached data to disk.

Any raster (or other GDAL) data written via GDAL calls, but buffered internally will be written to disk.

The default implementation of this method just calls the FlushCache() method on each of the raster bands and the SyncToDisk() method on each of the layers. Conceptionally, calling FlushCache() on a dataset should include any work that might be accomplished by calling SyncToDisk() on layers in that dataset.

Using this method does not prevent use from calling GDALClose() to properly close a dataset and ensure that important data not addressed by FlushCache() is written in the file.

This method is the same as the C function GDALFlushCache().

Reimplemented in GDALPamDataset, GDALProxyDataset, VRTDataset, and OGRMutexedDataSource.

GDALDriver * GDALDataset::GetDriver | ( | void |  | ) | `[virtual]`

Fetch the driver to which this dataset relates.

This method is the same as the C GDALGetDatasetDriver() function.

Returns:
  the driver on which the dataset was created with GDALOpen() or GDALCreate().

Reimplemented in GDALProxyDataset.

char ** GDALDataset::GetFileList | ( | void |  | ) | `[virtual]`

Fetch files forming dataset.

Returns a list of files believed to be part of this dataset. If it returns an empty list of files it means there is believed to be no local file system files associated with the dataset (for instance a virtual dataset). The returned file list is owned by the caller and should be deallocated with CSLDestroy().

The returned filenames will normally be relative or absolute paths depending on the path used to originally open the dataset. The strings will be UTF-8 encoded.

This method is the same as the C GDALGetFileList() function.

Returns:
  NULL or a NULL terminated array of file names.

Reimplemented in GDALPamDataset, GDALProxyDataset, GDALJP2AbstractDataset, VRTDataset, and VRTWarpedDataset.

int GDALDataset::GetGCPCount | ( |  | ) | `[virtual]`

Get number of GCPs.

This method is the same as the C function GDALGetGCPCount().

Returns:
  number of GCPs for this dataset. Zero if there are none.

Reimplemented in GDALPamDataset, GDALProxyDataset, GDALGeorefPamDataset, and VRTDataset.

const char * GDALDataset::GetGCPProjection | ( |  | ) | `[virtual]`

Get output projection for GCPs.

This method is the same as the C function GDALGetGCPProjection().

The projection string follows the normal rules from GetProjectionRef().

Returns:
  internal projection string or "" if there are no GCPs. It should not be altered, freed or expected to last for long.

Reimplemented in GDALPamDataset, GDALProxyDataset, GDALProxyPoolDataset, GDALGeorefPamDataset, and VRTDataset.

const GDAL_GCP * GDALDataset::GetGCPs | ( |  | ) | `[virtual]`

Fetch GCPs.

This method is the same as the C function GDALGetGCPs().

Returns:
  pointer to internal GCP structure list. It should not be modified, and may change on the next GDAL call.

Reimplemented in GDALPamDataset, GDALProxyDataset, GDALProxyPoolDataset, GDALGeorefPamDataset, and VRTDataset.

CPLErr GDALDataset::GetGeoTransform | ( | double * | padfTransform | ) | `[virtual]`

Fetch the affine transformation coefficients.

Fetches the coefficients for transforming between pixel/line (P,L) raster space, and projection coordinates (Xp,Yp) space.

       Xp = padfTransform[0] + P*padfTransform[1] + L*padfTransform[2];
       Yp = padfTransform[3] + P*padfTransform[4] + L*padfTransform[5];

In a north up image, padfTransform[1] is the pixel width, and padfTransform[5] is the pixel height. The upper left corner of the upper left pixel is at position (padfTransform[0],padfTransform[3]).

The default transform is (0,1,0,0,0,1) and should be returned even when a CE_Failure error is returned, such as for formats that don't support transformation to projection coordinates.

This method does the same thing as the C GDALGetGeoTransform() function.

Parameters:

  | padfTransform | an existing six double buffer into which the transformation will be placed.

Returns:
  CE_None on success, or CE_Failure if no transform can be fetched.

Reimplemented in GDALPamDataset, GDALProxyDataset, GDALProxyPoolDataset, GDALGeorefPamDataset, and VRTDataset.

OGRLayer * GDALDataset::GetLayerByName | ( | const char * | pszName | ) | `[virtual]`

Fetch a layer by name.

The returned layer remains owned by the GDALDataset and should not be deleted by the application.

This method is the same as the C function GDALDatasetGetLayerByName() and the deprecated OGR_DS_GetLayerByName().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | pszLayerName | the layer name of the layer to fetch.

Returns:
  the layer, or NULL if Layer is not found or an error occurs.

Reimplemented in OGRMutexedDataSource.

int GDALDataset::GetLayerCount | ( |  | ) | `[virtual]`

Get the number of layers in this dataset.

This method is the same as the C function GDALDatasetGetLayerCount(), and the deprecated OGR_DS_GetLayerCount().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Returns:
  layer count.

Reimplemented in GDALJP2AbstractDataset, and OGRMutexedDataSource.

GDALDataset ** GDALDataset::GetOpenDatasets | ( | int * | pnCount | ) | `[static]`

Fetch all open GDAL dataset handles.

This method is the same as the C function GDALGetOpenDatasets().

NOTE: This method is not thread safe. The returned list may change at any time and it should not be freed.

Parameters:

  | pnCount | integer into which to place the count of dataset pointers being returned.

Returns:
  a pointer to an array of dataset handles.

const char * GDALDataset::GetProjectionRef | ( | void |  | ) | `[virtual]`

Fetch the projection definition string for this dataset.

Same as the C function GDALGetProjectionRef().

The returned string defines the projection coordinate system of the image in OpenGIS WKT format. It should be suitable for use with the OGRSpatialReference class.

When a projection definition is not available an empty (but not NULL) string is returned.

Returns:
  a pointer to an internal projection reference string. It should not be altered, freed or expected to last for long.

See also:
  http://www.gdal.org/ogr/osr_tutorial.html

Reimplemented in GDALPamDataset, GDALProxyDataset, GDALProxyPoolDataset, GDALGeorefPamDataset, and VRTDataset.

GDALRasterBand * GDALDataset::GetRasterBand | ( | int | nBandId | ) |

Fetch a band object for a dataset.

Equivalent of the C function GDALGetRasterBand().

Parameters:

  | nBandId | the index number of the band to fetch, from 1 to GetRasterCount().

Returns:
  the nBandId th band object

int GDALDataset::GetRasterCount | ( | void |  | ) |

Fetch the number of raster bands on this dataset.

Same as the C function GDALGetRasterCount().

Returns:
  the number of raster bands.

int GDALDataset::GetRasterXSize | ( | void |  | ) |

Fetch raster width in pixels.

Equivalent of the C function GDALGetRasterXSize().

Returns:
  the width in pixels of raster bands in this GDALDataset.

int GDALDataset::GetRasterYSize | ( | void |  | ) |

Fetch raster height in pixels.

Equivalent of the C function GDALGetRasterYSize().

Returns:
  the height in pixels of raster bands in this GDALDataset.

int GDALDataset::GetRefCount | ( |  | ) | const

Fetch reference count.

This method is the same as the C function OGR_DS_GetRefCount().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Returns:
  the current reference count for the datasource object itself.

int GDALDataset::GetShared | ( |  | ) |

Returns shared flag.

Returns:
  TRUE if the GDALDataset is available for sharing, or FALSE if not.

OGRStyleTable * GDALDataset::GetStyleTable | ( |  | ) | `[virtual]`

Returns dataset style table.

This method is the same as the C function GDALDatasetGetStyleTable() and the deprecated OGR_DS_GetStyleTable().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Returns:
  pointer to a style table which should not be modified or freed by the caller.

Reimplemented in OGRMutexedDataSource.

int GDALDataset::GetSummaryRefCount | ( |  | ) | const

Fetch reference count of datasource and all owned layers.

This method is the same as the C function OGR_DS_GetSummaryRefCount().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Deprecated:

Returns:
  the current summary reference count for the datasource and its layers.

OGRLayer * GDALDataset::ICreateLayer | ( | const char * | pszName,
|  | OGRSpatialReference * | poSpatialRef = `NULL`,
|  | OGRwkbGeometryType | eGType = `wkbUnknown`,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | `[protected, virtual]`

This method attempts to create a new layer on the dataset with the indicated name, coordinate system, geometry type.

This method is reserved to implementation by drivers.

The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

Parameters:

  | pszName | the name for the new layer. This should ideally not match any existing layer on the datasource.
  | poSpatialRef | the coordinate system to use for the new layer, or NULL if no coordinate system is available.
  | eGType | the geometry type for the layer. Use wkbUnknown if there are no constraints on the types geometry to be written.
  | papszOptions | a StringList of name=value options. Options are driver specific.

Returns:
  NULL is returned on failure, or a new OGRLayer handle on success.

Since:
  GDAL 2.0

Reimplemented in OGRMutexedDataSource.

CPLErr GDALDataset::RasterIO | ( | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pData,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | GSpacing | nPixelSpace,
|  | GSpacing | nLineSpace,
|  | GSpacing | nBandSpace,
|  | GDALRasterIOExtraArg * | psExtraArg |
| ) |  |  |

Read/write a region of image data from multiple bands.

This method allows reading a region of one or more GDALRasterBands from this dataset into a buffer, or writing data from a buffer into a region of the GDALRasterBands. It automatically takes care of data type translation if the data type (eBufType) of the buffer is different than that of the GDALRasterBand. The method also takes care of image decimation / replication if the buffer size (nBufXSize x nBufYSize) is different than the size of the region being accessed (nXSize x nYSize).

The nPixelSpace, nLineSpace and nBandSpace parameters allow reading into or writing from various organization of buffers.

For highest performance full resolution data access, read and write on "block boundaries" as returned by GetBlockSize(), or use the ReadBlock() and WriteBlock() methods.

This method is the same as the C GDALDatasetRasterIO() or GDALDatasetRasterIOEx() functions.

Parameters:

  | eRWFlag | Either GF_Read to read a region of data, or GF_Write to write a region of data.
  | nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  | nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  | nXSize | The width of the region of the band to be accessed in pixels.
  | nYSize | The height of the region of the band to be accessed in lines.
  | pData | The buffer into which the data should be read, or from which it should be written. This buffer must contain at least nBufXSize * nBufYSize * nBandCount words of type eBufType. It is organized in left to right,top to bottom pixel order. Spacing is controlled by the nPixelSpace, and nLineSpace parameters.
  | nBufXSize | the width of the buffer image into which the desired region is to be read, or from which it is to be written.
  | nBufYSize | the height of the buffer image into which the desired region is to be read, or from which it is to be written.
  | eBufType | the type of the pixel values in the pData data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  | nBandCount | the number of bands being read or written.
  | panBandMap | the list of nBandCount band numbers being read/written. Note band numbers are 1 based. This may be NULL to select the first nBandCount bands.
  | nPixelSpace | The byte offset from the start of one pixel value in pData to the start of the next pixel value within a scanline. If defaulted (0) the size of the datatype eBufType is used.
  | nLineSpace | The byte offset from the start of one scanline in pData to the start of the next. If defaulted (0) the size of the datatype eBufType * nBufXSize is used.
  | nBandSpace | the byte offset from the start of one bands data to the start of the next. If defaulted (0) the value will be nLineSpace * nBufYSize implying band sequential organization of the data buffer.
  | psExtraArg | (new in GDAL 2.0) pointer to a GDALRasterIOExtraArg structure with additional arguments to specify resampling and progress callback, or NULL for default behaviour. The GDAL_RASTERIO_RESAMPLING configuration option can also be defined to override the default resampling to one of BILINEAR, CUBIC, CUBICSPLINE, LANCZOS, AVERAGE or MODE.

Returns:
  CE_Failure if the access fails, otherwise CE_None.

int GDALDataset::Reference | ( |  | ) |

Add one to dataset reference count.

The reference is one after instantiation.

This method is the same as the C GDALReferenceDataset() function.

Returns:
  the post-increment reference count.

void GDALDataset::ReleaseResultSet | ( | OGRLayer * | poResultsSet | ) | `[virtual]`

Release results of ExecuteSQL().

This method should only be used to deallocate OGRLayers resulting from an ExecuteSQL() call on the same GDALDataset. Failure to deallocate a results set before destroying the GDALDataset may cause errors.

This method is the same as the C function GDALDatasetReleaseResultSet() and the deprecated OGR_DS_ReleaseResultSet().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | poResultsSet | the result of a previous ExecuteSQL() call.

Reimplemented in OGRMutexedDataSource.

void GDALDataset::ReportError | ( | CPLErr | eErrClass,
|  | int | err_no,
|  | const char * | fmt,
|  |  | ... |
| ) |  |  |

Emits an error related to a dataset.

This function is a wrapper for regular CPLError(). The only difference with CPLError() is that it prepends the error message with the dataset name.

Parameters:

  | eErrClass | one of CE_Warning, CE_Failure or CE_Fatal.
  | err_no | the error number (CPLE_*) from cpl_error.h.
  | fmt | a printf() style format string. Any additional arguments will be treated as arguments to fill in this format in a manner similar to printf().

Since:
  GDAL 1.9.0

OGRErr GDALDataset::RollbackTransaction | ( |  | ) | `[virtual]`

For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction.

If no transaction is active, or the rollback fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_UNSUPPORTED_OPERATION.

This function is the same as the C function GDALDatasetRollbackTransaction().

Returns:
  OGRERR_NONE on success.

Since:
  GDAL 2.0

Reimplemented in OGRMutexedDataSource.

CPLErr GDALDataset::SetGCPs | ( | int | nGCPCount,
|  | const GDAL_GCP * | pasGCPList,
|  | const char * | pszGCPProjection |
| ) |  |  | `[virtual]`

Assign GCPs.

This method is the same as the C function GDALSetGCPs().

This method assigns the passed set of GCPs to this dataset, as well as setting their coordinate system. Internally copies are made of the coordinate system and list of points, so the caller remains responsible for deallocating these arguments if appropriate.

Most formats do not support setting of GCPs, even formats that can handle GCPs. These formats will return CE_Failure.

Parameters:

  | nGCPCount | number of GCPs being assigned.
  | pasGCPList | array of GCP structures being assign (nGCPCount in array).
  | pszGCPProjection | the new OGC WKT coordinate system to assign for the GCP output coordinates. This parameter should be "" if no output coordinate system is known.

Returns:
  CE_None on success, CE_Failure on failure (including if action is not supported for this format).

Reimplemented in GDALPamDataset, GDALProxyDataset, and VRTDataset.

void GDALDataset::SetStyleTable | ( | OGRStyleTable * | poStyleTable | ) | `[virtual]`

Set dataset style table.

This method operate exactly as SetStyleTableDirectly() except that it does not assume ownership of the passed table.

This method is the same as the C function GDALDatasetSetStyleTable() and the deprecated OGR_DS_SetStyleTable().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | poStyleTable | pointer to style table to set

Reimplemented in OGRMutexedDataSource.

void GDALDataset::SetStyleTableDirectly | ( | OGRStyleTable * | poStyleTable | ) | `[virtual]`

Set dataset style table.

This method operate exactly as SetStyleTable() except that it assumes ownership of the passed table.

This method is the same as the C function GDALDatasetSetStyleTableDirectly() and the deprecated OGR_DS_SetStyleTableDirectly().

In GDAL 1.X, this method used to be in the OGRDataSource class.

Parameters:

  | poStyleTable | pointer to style table to set

Reimplemented in OGRMutexedDataSource.

## Friends And Related Function Documentation

void GDALClose | ( | GDALDatasetH | hDS | ) | `[friend]`

Close GDAL dataset.

For non-shared datasets (opened with GDALOpen()) the dataset is closed using the C++ "delete" operator, recovering all dataset related resources. For shared datasets (opened with GDALOpenShared()) the dataset is dereferenced, and closed only if the referenced count has dropped below 1.

Parameters:

  | hDS | The dataset to close. May be cast from a "GDALDataset *".

GDALDatasetH GDALOpenEx | ( | const char * | pszFilename,
|  | unsigned int | nOpenFlags,
|  | const char *const * | papszAllowedDrivers,
|  | const char *const * | papszOpenOptions,
|  | const char *const * | papszSiblingFiles |
| ) |  |  | `[friend]`

Open a raster or vector file as a GDALDataset.

This function will try to open the passed file, or virtual dataset name by invoking the Open method of each registered GDALDriver in turn. The first successful open will result in a returned dataset. If all drivers fail then NULL is returned and an error is issued.

Several recommendations :

- If you open a dataset object with GDAL_OF_UPDATE access, it is not recommended to open a new dataset on the same underlying file.
- The returned dataset should only be accessed by one thread at a time. If you want to use it from different threads, you must add all necessary code (mutexes, etc.) to avoid concurrent use of the object. (Some drivers, such as GeoTIFF, maintain internal state variables that are updated each time a new block is read, thus preventing concurrent use.)

For drivers supporting the VSI virtual file API, it is possible to open a file in a .zip archive (see VSIInstallZipFileHandler()), in a .tar/.tar.gz/.tgz archive (see VSIInstallTarFileHandler()) or on a HTTP / FTP server (see VSIInstallCurlFileHandler())

In some situations (dealing with unverified data), the datasets can be opened in another process through the GDAL API Proxy mechanism.

In order to reduce the need for searches through the operating system file system machinery, it is possible to give an optional list of files with the papszSiblingFiles parameter. This is the list of all files at the same level in the file system as the target file, including the target file. The filenames must not include any path components, are an essentially just the output of CPLReadDir() on the parent directory. If the target object does not have filesystem semantics then the file list should be NULL.

Parameters:

  | pszFilename | the name of the file to access. In the case of exotic drivers this may not refer to a physical file, but instead contain information for the driver on how to access a dataset. It should be in UTF-8 encoding.
  | nOpenFlags | a combination of GDAL_OF_ flags that may be combined through logical or operator. Driver kind: GDAL_OF_RASTER for raster drivers, GDAL_OF_VECTOR for vector drivers. If none of the value is specified, both kinds are implied. Access mode: GDAL_OF_READONLY (exclusive)or GDAL_OF_UPDATE. Shared mode: GDAL_OF_SHARED. If set, it allows the sharing of GDALDataset handles for a dataset with other callers that have set GDAL_OF_SHARED. In particular, GDALOpenEx() will first consult its list of currently open and shared GDALDataset's, and if the GetDescription() name for one exactly matches the pszFilename passed to GDALOpenEx() it will be referenced and returned, if GDALOpenEx() is called from the same thread. Verbose error: GDAL_OF_VERBOSE_ERROR. If set, a failed attempt to open the file will lead to an error message to be reported.
  | papszAllowedDrivers | NULL to consider all candidate drivers, or a NULL terminated list of strings with the driver short names that must be considered.
  | papszOpenOptions | NULL, or a NULL terminated list of strings with open options passed to candidate drivers. An option exists for all drivers, OVERVIEW_LEVEL=level, to select a particular overview level of a dataset. The level index starts at 0. The level number can be suffixed by "only" to specify that only this overview level must be visible, and not sub-levels. Open options are validated by default, and a warning is emitted in case the option is not recognized. In some scenarios, it might be not desirable (e.g. when not knowing which driver will open the file), so the special open option VALIDATE_OPEN_OPTIONS can be set to NO to avoid such warnings.
  | papszSiblingFiles | NULL, or a NULL terminated list of strings that are filenames that are auxiliary to the main filename. If NULL is passed, a probing of the file system will be done.

Returns:
  A GDALDatasetH handle or NULL on failure. For C++ applications this handle can be cast to a GDALDataset *.

Since:
  GDAL 2.0

The documentation for this class was generated from the following files:

- gdal_priv.h
- gdaldataset.cpp
- rasterio.cpp

Generated for GDAL by 1.7.1.